stages:
  - build
  - test
  - release

variables:
  build_tag: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  release_tag: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME

.job:
  before_script:
    - docker version
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY

build:
  extends: .job
  stage: build
  script:
    - make
    - docker push $build_tag
  tags:
    - build

test:
  extends: .job
  stage: test
  script:
    - docker pull $build_tag
    - make test
  tags:
    - test

release:
  extends: .job
  stage: release
  script:
    - docker pull $build_tag
    - docker tag $build_tag $release_tag
    - docker push $release_tag
  only:
    refs:
      - develop
      - main
      - v1
  tags:
    - release
